% For display of selected weak classifiers by adaboost
function displaySelectedFilters(lambdas,selectedFeatures,lattice,patch_size,folder)

scale = .7;  % scale of Gabors
norient = 15;  % number of orientations
epsilon = .1;  % allowed correlation between selected Gabors
T = 4.;        % threshold for responses
[allfilter, allsymbol] = makefilter(scale, norient);  % generate Gabor filters 

imPos = zeros(patch_size); % show basis where lambdas are positive
imNeg = zeros(patch_size);

maxLambda = max(abs(lambdas));
lambdas = floor(lambdas / maxLambda * 254);


for k = 1:size(selectedFeatures,1)
    filterIndex = selectedFeatures(k).params(1);
    orientationIndex = ceil(filterIndex/size(lattice,1)/size(lattice,2));
    locationIndex = filterIndex - (orientationIndex-1)*size(lattice,1)*size(lattice,2);
    locationInPatch = lattice(locationIndex);
    col = ceil(locationInPatch / patch_size(1));
    row = locationInPatch - (col-1)*patch_size(1);
    if lambdas(k) >= 0
        imPos = drawGaborSymbol(imPos, allsymbol, row, col, orientationIndex, lambdas(k));
    else
        imNeg = drawGaborSymbol(imNeg, allsymbol, row, col, orientationIndex, -1*lambdas(k));
    end
end

toDisplay = uint8(zeros(patch_size(1),patch_size(2),3));
toDisplay(:,:,2) = uint8(255-imPos);
toDisplay(:,:,1) = uint8(255-imNeg);
toDisplay(:,:,3) = 255;
% h=figure;imshow(toDisplay);
% saveas(h,[folder '/selectedBasis.jpg']);
imwrite(toDisplay,[folder '/selectedBasis.jpg']);
